Package org.apache.lucene.codecs.hnsw

# Class FlatVectorsReader

java.lang.Object
org.apache.lucene.codecs.KnnVectorsReader
org.apache.lucene.codecs.hnsw.FlatVectorsReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Accountable`

Direct Known Subclasses:
  `Lucene99FlatVectorsReader`, `Lucene99ScalarQuantizedVectorsReader`

public abstract class FlatVectorsReader extends KnnVectorsReader implements Accountable
Reads vectors from an index. When searching this reader, it iterates every vector in the index and scores them

This class is useful when:

- the number of vectors is small
- when used along side some additional indexing structure that can be used to better search the vectors (like HNSW).

WARNING: This API is experimental and might change in incompatible ways in the next release.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final FlatVectorsScorer`
`vectorScorer`
Scorer for flat vectors

### Fields inherited from interface org.apache.lucene.util.Accountable

`NULL_ACCOUNTABLE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`FlatVectorsReader(FlatVectorsScorer vectorsScorer)`
Sole constructor

## Method Summary

Modifier and Type
Method
Description
`FlatVectorsScorer`
`getFlatVectorScorer()`
`abstract RandomVectorScorer`
`getRandomVectorScorer(String field, byte[] target)`
Returns a `RandomVectorScorer` for the given field and target vector.
`abstract RandomVectorScorer`
`getRandomVectorScorer(String field, float[] target)`
Returns a `RandomVectorScorer` for the given field and target vector.
`void`
`search(String field, byte[] target, KnnCollector knnCollector, Bits acceptDocs)`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
`void`
`search(String field, float[] target, KnnCollector knnCollector, Bits acceptDocs)`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.

### Methods inherited from class org.apache.lucene.codecs.KnnVectorsReader

`checkIntegrity, getByteVectorValues, getFloatVectorValues, getMergeInstance`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.lucene.util.Accountable

`getChildResources, ramBytesUsed`

### Methods inherited from interface java.io.Closeable

`close`

## Field Details

### vectorScorer

protected final FlatVectorsScorer vectorScorer
Scorer for flat vectors

## Constructor Details

### FlatVectorsReader

protected FlatVectorsReader(FlatVectorsScorer vectorsScorer)
Sole constructor

## Method Details

### getFlatVectorScorer

public FlatVectorsScorer getFlatVectorScorer()

Returns:
  the `FlatVectorsScorer` for this reader.

### search

public void search(String field, float[] target, KnnCollector knnCollector, Bits acceptDocs) throws IOException
Description copied from class: `KnnVectorsReader`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

Specified by:
  `search` in class `KnnVectorsReader`
Parameters:
  `field` - the vector field to search
  `target` - the vector-valued query
  `knnCollector` - a KnnResults collector and relevant settings for gathering vector results
  `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
Throws:
  `IOException`

### search

public void search(String field, byte[] target, KnnCollector knnCollector, Bits acceptDocs) throws IOException
Description copied from class: `KnnVectorsReader`
Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

Specified by:
  `search` in class `KnnVectorsReader`
Parameters:
  `field` - the vector field to search
  `target` - the vector-valued query
  `knnCollector` - a KnnResults collector and relevant settings for gathering vector results
  `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
Throws:
  `IOException`

### getRandomVectorScorer

public abstract RandomVectorScorer getRandomVectorScorer(String field, float[] target) throws IOException
Returns a `RandomVectorScorer` for the given field and target vector.

Parameters:
  `field` - the field to search
  `target` - the target vector
Returns:
  a `RandomVectorScorer` for the given field and target vector.
Throws:
  `IOException` - if an I/O error occurs when reading from the index.

### getRandomVectorScorer

public abstract RandomVectorScorer getRandomVectorScorer(String field, byte[] target) throws IOException
Returns a `RandomVectorScorer` for the given field and target vector.

Parameters:
  `field` - the field to search
  `target` - the target vector
Returns:
  a `RandomVectorScorer` for the given field and target vector.
Throws:
  `IOException` - if an I/O error occurs when reading from the index.